<template>

<OverlayBase
    v-bind:title="this.$t('chooseTemplate')"
>
    <div class="
        flex
        pb-4
    ">
        <Button
            class="mr-4 w-40"
            v-if="project.currentTemplate"
            icon="grid"
            v-bind:name="project.currentTemplate.name + this.$t('fromOpenedFile')"
            v-on:click="$emit('change', project.currentTemplate)"
        />
        <Button
            v-if="favoriteTemplate"
            class="mr-4 w-40"
            icon="grid"
            v-bind:name="favoriteTemplate.name + this.$t('asFavTemplate')"
            v-on:click="$emit('change', favoriteTemplate)"
        />
        <Button
            icon="filePlus"
            v-bind:name="this.$t('openTemplate')"
            v-on:click="$refs.fileReport.click()"
        />
        <input
            v-on:change="$emit('upload', $event.target.files)"
            accept=".xls, .xlsx"
            type="file"
            ref="fileReport"
            class="
            hidden
        ">
    </div>

    <button v-on:click="$emit('close')" class="
        btn-red
    ">
        {{ this.$t('close') }}
    </button>
</OverlayBase>

</template>

<script lang="ts">

import { Component, Prop, Vue } from 'vue-property-decorator';
import { State } from 'vuex-class';

import OverlayBase from '@/components/OverlayBase.vue';

import { Exporter } from '@/ts/exporter';
import { Factory } from '@/ts/factory';
import { Project } from '@/ts/project';
import { Saver } from '@/ts/saver';
import * as database from '@/ts/utils/database';

import Button from '../../Button.vue';

@Component({
    components: {
        Button,
        OverlayBase,
    },
})
export default class C extends Vue {
    @State('factory')
    private factory!: Factory;

    @State('project')
    private project!: Project;

    private favoriteTemplate: any = null;

    private database: any = database;

    private async mounted() {
        this.favoriteTemplate = (await database.getFavoriteTemplate()) || null;
    }
}

</script>
